"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Original = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _react = require("react");
var _state = require("@codemirror/state");
var _view = require("@codemirror/view");
var _reactCodemirror = require("@uiw/react-codemirror");
var _store = require("./store");
var External = _state.Annotation.define();
var Original = function Original(props) {
  var _props$extensions = props.extensions,
    extensions = _props$extensions === void 0 ? [] : _props$extensions,
    onChange = props.onChange;
  var _useStore = (0, _store.useStore)(),
    original = _useStore.original,
    view = _useStore.view,
    dispatch = _useStore.dispatch;
  var defaultExtensions = (0, _reactCodemirror.getDefaultExtensions)();
  var updateListener = _view.EditorView.updateListener.of(function (vu) {
    if (vu.docChanged && typeof onChange === 'function' &&
    // Fix echoing of the remote changes:
    // If transaction is market as remote we don't have to call `onChange` handler again
    !vu.transactions.some(function (tr) {
      return tr.annotation(External);
    })) {
      var doc = vu.state.doc;
      var _value = doc.toString();
      onChange(_value, vu);
    }
  });
  var extensionsData = [updateListener].concat((0, _toConsumableArray2["default"])(defaultExtensions), (0, _toConsumableArray2["default"])(extensions));
  var data = {
    extensions: (0, _toConsumableArray2["default"])(extensionsData)
  };
  (0, _react.useEffect)(function () {
    dispatch({
      original: (0, _objectSpread2["default"])({
        doc: props.value,
        selection: props.selection
      }, data)
    });
  }, []);
  (0, _react.useEffect)(function () {
    if ((original === null || original === void 0 ? void 0 : original.doc) !== props.value && view) {
      data.doc = props.value;
      dispatch({
        original: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, original), data)
      });
      var originalDoc = view === null || view === void 0 ? void 0 : view.a.state.doc.toString();
      if (originalDoc !== props.value) {
        view === null || view === void 0 ? void 0 : view.a.dispatch({
          changes: {
            from: 0,
            to: (originalDoc || '').length,
            insert: props.value || ''
          },
          effects: _state.StateEffect.appendConfig.of((0, _toConsumableArray2["default"])(extensionsData)),
          annotations: [External.of(true)]
        });
      }
    }
    if ((original === null || original === void 0 ? void 0 : original.selection) !== props.selection) {
      data.selection = props.selection;
      dispatch({
        original: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, original), data)
      });
    }
  }, [props.value, props.selection, view]);
  return null;
};
exports.Original = Original;
Original.displayName = 'CodeMirrorMerge.Original';