import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["className", "children", "orientation", "revertControls", "highlightChanges", "gutter", "collapseUnchanged", "renderRevertControl"],
  _excluded2 = ["modified", "original", "view", "dispatch"];
import React, { useEffect, useImperativeHandle, useRef } from 'react';
import { MergeView } from '@codemirror/merge';
import { useStore } from './store';
import { jsx as _jsx } from "react/jsx-runtime";
export var Internal = /*#__PURE__*/React.forwardRef((props, ref) => {
  var {
      className,
      children,
      orientation,
      revertControls,
      highlightChanges,
      gutter,
      collapseUnchanged,
      renderRevertControl
    } = props,
    elmProps = _objectWithoutPropertiesLoose(props, _excluded);
  var _useStore = useStore(),
    {
      modified,
      original,
      view,
      dispatch
    } = _useStore,
    otherStore = _objectWithoutPropertiesLoose(_useStore, _excluded2);
  var editor = useRef(null);
  useImperativeHandle(ref, () => ({
    container: editor.current,
    view
  }), [editor, view]);
  useEffect(() => {
    if (!view && editor.current && original != null && original.extensions && modified != null && modified.extensions) {
      var opts = {
        orientation,
        revertControls,
        highlightChanges,
        gutter,
        collapseUnchanged,
        renderRevertControl
      };
      var viewDefault = new MergeView(_extends({
        a: original,
        b: modified,
        parent: editor.current
      }, opts));
      dispatch && dispatch(_extends({
        view: viewDefault
      }, opts));
    }
  }, [editor.current, original, modified, view]);
  useEffect(() => () => view && view.destroy(), []);
  useEffect(() => {
    if (view) {
      var opts = {};
      if (otherStore.orientation !== orientation) {
        opts.orientation = orientation;
      }
      if (otherStore.revertControls !== revertControls) {
        opts.revertControls = revertControls;
      }
      if (otherStore.highlightChanges !== highlightChanges) {
        opts.highlightChanges = highlightChanges;
      }
      if (otherStore.gutter !== gutter) {
        opts.gutter = gutter;
      }
      if (otherStore.collapseUnchanged !== collapseUnchanged) {
        opts.collapseUnchanged = collapseUnchanged;
      }
      if (Object.keys(opts).length && dispatch && original && modified && editor.current) {
        view.destroy();
        var viewDefault = new MergeView(_extends({
          a: original,
          b: modified,
          parent: editor.current
        }, opts));
        dispatch(_extends({}, opts, {
          renderRevertControl,
          view: viewDefault
        }));
      }
    }
  }, [view, original, modified, editor, orientation, revertControls, highlightChanges, gutter, collapseUnchanged, renderRevertControl]);
  var defaultClassNames = 'cm-merge-theme';
  return /*#__PURE__*/_jsx("div", _extends({
    ref: editor,
    className: "" + defaultClassNames + (className ? " " + className : '')
  }, elmProps, {
    children: children
  }));
});
Internal.displayName = 'CodeMirrorMerge.Internal';